%define         _disable_ld_no_undefined 0

%define         major                    1

%define         cxx_major                1
%define         usempi_major             1
%define         usempif08_major          0
%define         usempi_ignore_major      0
%define         mpifh_major              2
%define         vt_major                 0
%define         ompitrace_major          0
%define         opentrace_major          1
%define         openpal_major            6
%define         openrte_major            7
%define         otfaux_major             0
%define         oshmem_major             3

%define         libname                  %mklibname %{name} %{major}
%define         develname                %mklibname %{name} -d
%define         staticdevelname          %mklibname %{name} -s -d

%define         gccinstalldir   %(LC_ALL=C %__cc --print-search-dirs | %__grep install | %__awk '{print $2}')
%define         fincludedir     %{gccinstalldir}finclude


Summary:        An implementation of the Message Passing Interface
Name:           openmpi
Version:        1.8.4
Release:        %mkrel 1
License:        BSD
Group:          Development/Other

URL:            http://www.open-mpi.org
Source0:        http://www.open-mpi.org/software/ompi/v1.8/downloads/openmpi-%{version}.tar.xz
Patch0:         ompi_autogen_sh.patch
Patch1:         arm_detection.diff

BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gawk
BuildRequires:  pkgconfig(pkg-config)
BuildRequires:  gcc-gfortran
BuildRequires:  java-1.8.0-sun
BuildRequires:  quadmath-devel
BuildRequires:  gcc-c++
BuildRequires:  binutils-devel
BuildRequires:  libibverbs-devel
BuildRequires:  libgomp-devel
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(hwloc)
BuildRequires:  hwloc
BuildRequires:  autoconf

Requires:       %{libname} = %{version}-%{release}
Recommends:       %{develname} = %{version}-%{release}

Conflicts:      mpich
Conflicts:      mpich2
Conflicts:      lam


%description
The Open MPI Project is an open source fully compliant MPI-3
implementation that is developed and maintained by a consortium of
academic, research, and industry partners. OpenMPI is therefore able
to combine the expertise, technologies, and resources from all across
the High Performance Computing community in order to build the best
MPI library available. OpenMPI offers advantages for system and
software vendors, application developers and computer science
researchers. This package contains all of the tools necessary to
compile, link, and run OpenMPI jobs.



%package -n %{libname}
Summary:        Shared libraries for OpenMPI
Group:          Development/Libraries
Provides:       lib%{name} = %{version}-%{release}

%description -n %{libname}
%{summary}.


%package -n %{develname}
Summary:        Development files for OpenMPI
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}
#was Requires
Recommends:       %{name} = %{version}-%{release}
Requires:       gcc-gfortran 
Requires:       gcc-c++
Provides:       lib%{name}-devel  = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Conflicts:      lam-devel
Conflicts:      mpich1-devel
Conflicts:      mpich2-devel

%description -n %{develname}
%{summary}.


%package -n %{staticdevelname}
Summary:        Static Development files for OpenMPI
Group:          Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Requires:       gcc-gfortran 
Requires:       gcc-c++
Provides:       lib%{name}-static-devel  = %{version}-%{release}
Provides:       %{name}-static-devel = %{version}-%{release}
Conflicts:      lam-devel
Conflicts:      mpich1-devel
Conflicts:      mpich2-devel

%description -n %{staticdevelname}
%{summary}.


%prep
%setup -q -n %{name}-%{version}



%build
%configure2_5x --enable-shared --enable-static \
               --enable-mpi-thread-multiple \
               --with-threads=posix \
               --with-hwloc=%{_prefix}

%make


%install
%makeinstall_std

%__rm -rf %{buildroot}%{_sysconfdir}/openmpi-totalview.tcl
%__rm -rf %{buildroot}%{_datadir}/libtool
%__rm -f %{buildroot}%{_datadir}/config.log
%__rm -f %{buildroot}%{_datadir}/omp.h


%__install -D -m 644 %{buildroot}%{_libdir}/mpi.mod %{buildroot}%{fincludedir}/mpi.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_ext.mod %{buildroot}%{fincludedir}/mpi_ext.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08.mod %{buildroot}%{fincludedir}/mpi_f08.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_ext.mod %{buildroot}%{fincludedir}/mpi_f08_ext.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_interfaces.mod %{buildroot}%{fincludedir}/mpi_f08_interfaces.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_interfaces_callbacks.mod %{buildroot}%{fincludedir}/mpi_f08_interfaces_callbacks.mod
#__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_sizeof.mod %{buildroot}%{fincludedir}/mpi_f08_sizeof.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_types.mod %{buildroot}%{fincludedir}/mpi_f08_types.mod
%__install -D -m 644 %{buildroot}%{_libdir}/pmpi_f08_interfaces.mod %{buildroot}%{fincludedir}/pmpi_f08_interfaces.mod
%__rm %{buildroot}%{_libdir}/*.mod
pushd %{buildroot}%{_libdir}
%__ln_s %{fincludedir}/*.mod  .
popd

find %{buildroot}%{_libdir} -name *.la -delete



%files
%doc README LICENSE NEWS AUTHORS
%config(noreplace) %{_sysconfdir}/*
%{_bindir}/mpirun
%{_bindir}/mpiexec
%{_bindir}/orted
%{_bindir}/orte-*
%{_bindir}/orterun
%{_bindir}/ompi-*
%{_bindir}/otf*
%{_bindir}/osh*
%{_bindir}/shmem*
%{_datadir}/%{name}/*.txt
%{_datadir}/%{name}/amca*
%{_datadir}/%{name}/*.supp
%{_datadir}/%{name}/mca*
%{_mandir}/man1/mpirun*
%{_mandir}/man1/mpiexec*
%{_mandir}/man1/orte*
%{_mandir}/man1/oshmem*
%{_mandir}/man1/ompi-*
%{_mandir}/man7/*


#may be splitted at some point
%files -n %{libname} 
%doc %{_datadir}/%{name}/doc/COPYRIGHT-ptmalloc2.txt
%{_libdir}/libmpi.so.%{major}*
%{_libdir}/libmpi_c*.so.%{cxx_major}*
%{_libdir}/libmpi_usempi.so.%{usempi_major}*
%{_libdir}/libmpi_usempif08.so.%{usempif08_major}*
%{_libdir}/libmpi_usempi_ignore*.so.%{usempi_ignore_major}*
%{_libdir}/libmpi_mpifh*.so.%{mpifh_major}*
%{_libdir}/libvt*.so.%{vt_major}*
%{_libdir}/libompitrace*.so.%{ompitrace_major}*
%{_libdir}/libopen-trace*.so.%{opentrace_major}*
%{_libdir}/libopen-pal*.so.%{openpal_major}*
%{_libdir}/libopen-rte*.so.%{openrte_major}*
%{_libdir}/libotfaux*.so.%{otfaux_major}*
%{_libdir}/liboshmem*.so.%{oshmem_major}*


%files -n %{develname}
%doc examples/
%doc %{_datadir}/vampirtrace
%{_bindir}/mpif*
%{_bindir}/mpic*
%{_bindir}/mpiC*
%{_bindir}/ortec*
%{_bindir}/opal*
%{_bindir}/opari*
%{_bindir}/vt*
%{_bindir}/ompi_*
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/%{name}/*.so
%{_libdir}/*.mod
%{fincludedir}/*.mod
%{_libdir}/pkgconfig/*.pc
%{_datadir}/%{name}/mpi*
%{_mandir}/man1/mpif*
%{_mandir}/man1/mpic*
%{_mandir}/man1/mpiC*
%{_mandir}/man1/ompi_*
%{_mandir}/man1/opal_wrapper*
%{_mandir}/man3/*



%files -n %{staticdevelname}
%{_libdir}/*.a
%{_libdir}/%{name}/*.a


%changelog
* Fri Apr 03 2015 bb <bb> 1.8.4-1pclos2015
- import from france
